export type Parameter = {
  [param: string]: string | string[];
} | null;

export class ParameterUtil {
  public static encode(
    parameterMap: {},
    param: {},
    extraParam?: {}
  ): Parameter {
    const parameter: Parameter = {};

    Object.keys(parameterMap).map(key => {
      if (!param.hasOwnProperty(key)) {
        return;
      }

      let v: any;
      if (!!extraParam && !!extraParam[key]) {
        v = extraParam[key];
      } else if (!!param[key]) {
        v = param[key];
      }

      if (!!v) {
        parameter[parameterMap[key]] = v;
      }
    });

    return 0 === Object.keys(parameter).length ? null : parameter;
  }

  public static encodeFormData(
    parameterMap: {},
    param: {},
    extraParam?: {}
  ): FormData {
    const formData: FormData = new FormData();

    Object.keys(parameterMap).map(key => {
      if (!param.hasOwnProperty(key)) {
        return;
      }

      let v: any;
      if (!!extraParam && !!extraParam[key]) {
        v = extraParam[key];
      } else if (!!param[key]) {
        v = param[key];
      }

      if (!!v) {
        if (v instanceof File) {
          formData.append(parameterMap[key], v, v.name);
        } else {
          formData.append(parameterMap[key], v);
        }
      }
    });

    return formData;
  }
}
